#ifndef __MEMORY_H
#define __MEMORY_H

#include "GameStateModule.H"
#include "Game.H"
#include "ServerObjData.H"

struct Unit {
	int gob_id;
	sint4 x;
	sint4 y;
	sint4 hp;
	sint4 x2;
	sint4 y2;
	sint4 last_tick_shoot;
};


#define MAX_UNITS 70

class Memory {
	public:
	Memory() {
		for (int i = 0; i < MAX_UNITS; ++i) {
			mate[i].gob_id = 0;
			enemy[i].gob_id = 0;
			mate[i].last_tick_shoot = -1;
			enemy[i].last_tick_shoot = -1;
		}
		init = false;
	}
	bool init;
	Unit mate[MAX_UNITS];
	Unit enemy[MAX_UNITS];
};

extern class Memory m;

void show_memory(Memory& m);
Unit* find_enemy(GameObj* gob, Memory& m);
Unit* find_mate(GameObj* gob, Memory& m);
void memory_init(const Game& game, Memory& m);
void remember_enemies(const Game& game, Memory& m);
void remember_unit(GameObj* gob, Unit* u, float x, float y, int last_tick_shoot);

#endif
