#include <math.h>
#include <stdio.h>

#include "consts.H"
#include "terminals.H"
#include "parser.H"


Tuple& VEC(double a, double b) {
	Tuple* tp = new Tuple();
	if (t.home_team.x > MAXX/2) {
		tp->x = -a;
	} else { 
		tp->x = a;
	}
	tp->y = b;
	return (*tp);
}

Tuple& MIN(Tuple& a, Tuple& b) {
	return IF(LT(LEN(a),LEN(b)),a,b);
}

Tuple& MAX(Tuple& a, Tuple& b) {
	return IF(LT(LEN(a),LEN(b)),b,a);
}

double MIN(double a, double b) {
	return (a) < (b) ? (a) : (b);
}

double MAX(double a, double b) {
	return (a) > (b) ? (a) : (b);
}

Tuple& ADD(Tuple& a, Tuple& b) {
	a.x += b.x;
	a.y += b.y;
	return a;
}

double ADD(double a, double b) {
	return a + b;
}

bool ADD(bool a, bool b) {
	return a || b;
}

Tuple& SUB(Tuple& a, Tuple& b) {
	a.x -= b.x;
	a.y -= b.y;
	return a;
}

double SUB(double a, double b) {
	return a - b;
}

Tuple& MUL(double a, Tuple& b) {
	b.x *= a;
	b.y *= a;
	return b;
}

double MUL(double a, double b) {
	return a * b;
}

bool MUL(bool a, bool b) {
	return a && b;
}

double OPP(double a) {
	return -a;
}

Tuple& OPP(Tuple& a) {
	a.x *= -1;
	a.y *= -1;
	return a;
}

bool OPP(bool a) {
	return a == true ? false : true;
}

double LEN(Tuple& a) {
	return sqrt(a.x*a.x+a.y*a.y);
}

Tuple& NOR(Tuple& a) {
	float absx = a.x;
	float absy = a.y;
	if (absx < 0) absx *= -1;
	if (absy < 0) absy *= -1;
	
	if (absx > absy) {
		if (absx < EPSILON) {
			a.y = 0;
			a.x = 0;
		} else {
			a.y /= absx;
			if (a.x > 0) {
				a.x = 1;
			} else {
				a.x = -1;
			}
		}
	} else if (absx < absy) {
		if (absy < EPSILON) {
			a.x = 0;
			a.y = 0;
		} else {
			a.x /= absy;
			if (a.y > 0) {
				a.y = 1;
			} else {
				a.y = -1;
			}
		}		
	} else {
		if (a.x > EPSILON) {
			a.x = 1;
		} else if (a.x < -EPSILON) {
			a.x = -1;
		} else {
			a.x = 0;
		}
		
		if (a.y > EPSILON) {
			a.y = 1;
		} else if (a.y < -EPSILON) {
			a.y = -1;
		} else {
			a.y = 0;
		}
	}
	return a;
}

Tuple& ROT(double a, Tuple& b) {
	double x = cos(a)*b.x - sin(a)*b.y;
	double y = sin(a)*b.x + cos(a)*b.y;
	b.x = x;
	b.y = y;
	return b;
}

Tuple& RIG(Tuple& b) {
	double a = 1.57;
	return ROT(a, b);
}

Tuple& LEF(Tuple& b) {
	double a = -1.57;
	return ROT(a, b);
}


